/******************************************************************************

   Atari ST keyboard scan codes

******************************************************************************/

/* function keys, without Shift modifier */
#define SCAN_f1 0x3b
#define SCAN_f2 0x3c
#define SCAN_f3 0x3d
#define SCAN_f4 0x3e
#define SCAN_f5 0x3f
#define SCAN_f6 0x40
#define SCAN_f7 0x41
#define SCAN_f8 0x42
#define SCAN_f9 0x43
#define SCAN_f10 0x44

/* function keys, with Shift modifier */
#define SCAN_F1 0x54
#define SCAN_F2 0x55
#define SCAN_F3 0x56
#define SCAN_F4 0x57
#define SCAN_F5 0x58
#define SCAN_F6 0x59
#define SCAN_F7 0x5a
#define SCAN_F8 0x5b
#define SCAN_F9 0x5c
#define SCAN_F10 0x5d

/* top row, without Alternate modifier */
#define SCAN_ESC 0x01
#define SCAN_1 0x02
#define SCAN_2 0x03
#define SCAN_3 0x04
#define SCAN_4 0x05
#define SCAN_5 0x06
#define SCAN_6 0x07
#define SCAN_7 0x08
#define SCAN_8 0x09
#define SCAN_9 0x0a
#define SCAN_0 0x0b
#define SCAN_DASH 0x0c
#define SCAN_EQUAL 0x0d
#define SCAN_TILDE 0x29
#define SCAN_BS 0x0e

/* top row, with Alternate modifier */
#define SCAN_ALT1 0x78
#define SCAN_ALT2 0x79
#define SCAN_ALT3 0x7A
#define SCAN_ALT4 0x7B
#define SCAN_ALT5 0x7C
#define SCAN_ALT6 0x7D
#define SCAN_ALT7 0x7E
#define SCAN_ALT8 0x7F
#define SCAN_ALT9 0x80
#define SCAN_ALT0 0x81

/* second row */
#define SCAN_TAB 0x0f
#define SCAN_Q 0x10
#define SCAN_W 0x11
#define SCAN_E 0x12
#define SCAN_R 0x13
#define SCAN_T 0x14
#define SCAN_Y 0x15
#define SCAN_U 0x16
#define SCAN_I 0x17
#define SCAN_O 0x18
#define SCAN_P 0x19
#define SCAN_LBRACE 0x1a
#define SCAN_RBRACE 0x1b
#define SCAN_DEL 0x53

/* third row */
#define SCAN_A 0x1e
#define SCAN_S 0x1f
#define SCAN_D 0x20
#define SCAN_F 0x21
#define SCAN_G 0x22
#define SCAN_H 0x23
#define SCAN_J 0x24
#define SCAN_K 0x25
#define SCAN_L 0x26
#define SCAN_COLON 0x27
#define SCAN_QUOTE 0x28
#define SCAN_BSLASH 0x2b

/* fourth row */
#define SCAN_Z 0x2c
#define SCAN_X 0x2d
#define SCAN_C 0x2e
#define SCAN_V 0x2f
#define SCAN_B 0x30
#define SCAN_N 0x31
#define SCAN_M 0x32
#define SCAN_COMMA 0x33
#define SCAN_PERIOD 0x34
#define SCAN_SLASH 0x35

/* special keys */
#define SCAN_HELP 0x62
#define SCAN_UNDO 0x61
#define SCAN_INS 0x52
#define SCAN_UP 0x48
#define SCAN_CLR 0x47
#define SCAN_LEFT 0x4b
#define SCAN_DOWN 0x50
#define SCAN_RIGHT 0x4d
#define SCAN_CLEFT 0x73      /* with Control modifier */
#define SCAN_CRIGHT 0x74     /* with Control modifier */
#define SCAN_SPACE 0x39
#define SCAN_CR 0x1c

/* numeric keypad */
#define SCAN_LPAREN 0x63
#define SCAN_RPAREN 0x64
#define SCAN_DIV 0x65
#define SCAN_MULT 0x66
#define SCAN_NUM7 0x67
#define SCAN_NUM8 0x68
#define SCAN_NUM9 0x69
#define SCAN_SUB 0x4a
#define SCAN_NUM4 0x6a
#define SCAN_NUM5 0x6b
#define SCAN_NUM6 0x6c
#define SCAN_ADD 0x4e
#define SCAN_NUM1 0x6d
#define SCAN_NUM2 0x6e
#define SCAN_NUM3 0x6f
#define SCAN_ENTER 0x72
#define SCAN_NUM0 0x70
#define SCAN_DECPT 0x71

/* EOF */
